- introduce variable _BB_CONFIG_DEP to the new test harness.
authorBernhard Reutner-Fischer <rep.dot.nop@gmail.com>
Fri, 23 Sep 2005 15:44:46 +0000 (15:44 -0000)
committerBernhard Reutner-Fischer <rep.dot.nop@gmail.com>
Fri, 23 Sep 2005 15:44:46 +0000 (15:44 -0000)
  This is used to see if given tests should be run (are available) or not.
  Print "UNTESTED: descr" if the applet or feature is not available.
- add _BB_CONFIG_DEP to existing new.tests
- move old grep test to new test infrastructure and add a few more test for
  grep.

13 files changed:
testsuite/busybox.tests
testsuite/egrep.tests [new file with mode: 0755]
testsuite/grep.tests [new file with mode: 0644]
testsuite/grep/egrep-is-not-case-insensitive [deleted file]
testsuite/grep/egrep-supports-extended-regexps [deleted file]
testsuite/grep/grep-handles-binary-files [deleted file]
testsuite/grep/grep-handles-multiple-regexps [deleted file]
testsuite/grep/grep-is-also-egrep [deleted file]
testsuite/grep/grep-matches-NUL [deleted file]
testsuite/runtest
testsuite/sort.tests
testsuite/testing.sh
testsuite/uniq.tests

index 91dbc797eea17bc0a7e7a741d1480e9012b92bd9..7595d061fdeaea9414b8c18a1842db6027745a78 100755 (executable)
@@ -7,6 +7,9 @@
 if [ ${#COMMAND} -eq 0 ]; then COMMAND=busybox; fi
 . testing.sh
 
+# Depends on nothing
+_BB_CONFIG_DEP=""
+
 # We'll assume "cat" is built in, because we need some other command to test.
 
 HELPDUMP=`$COMMAND`
diff --git a/testsuite/egrep.tests b/testsuite/egrep.tests
new file mode 100755 (executable)
index 0000000..b634649
--- /dev/null
@@ -0,0 +1,20 @@
+#!/bin/sh
+
+# egrep tests.
+# Copyright 2005 by Rob Landley <rob@landley.net>
+# Licensed under GPL v2, see file LICENSE for details.
+
+# AUDIT: 
+
+[ ${#COMMAND} -eq 0 ] && COMMAND=egrep
+. testing.sh
+
+# Depends on FEATURE_GREP_EGREP_ALIAS
+_BB_CONFIG_DEP=FEATURE_GREP_EGREP_ALIAS
+
+testing "grep is also egrep" "foo" "foo\n" "" "foo\nbar\n"
+testing "egrep is not case insensitive" "foo ; [ \$? -ne 0 ] && echo yes" \
+       "yes\n" "" "FOO\n"
+
+
+exit $FAILCOUNT
diff --git a/testsuite/grep.tests b/testsuite/grep.tests
new file mode 100644 (file)
index 0000000..c4f534d
--- /dev/null
@@ -0,0 +1,82 @@
+#!/bin/sh
+
+# grep tests.
+# Copyright 2005 by Rob Landley <rob@landley.net>
+# Licensed under GPL v2, see file LICENSE for details.
+
+# AUDIT: 
+
+[ ${#COMMAND} -eq 0 ] && COMMAND=grep
+. testing.sh
+
+# Depends on grep
+_BB_CONFIG_DEP=grep
+
+# testing "test name" "options" "expected result" "file input" "stdin"
+#   file input will be file called "input"
+#   test can create a file "actual" instead of writing to stdout
+
+# Test exit status
+
+testing "grep (exit with error)" "nonexistent 2> /dev/null ; echo \$?" \
+       "1\n" "" ""
+testing "grep (exit success)" "grep $0 > /dev/null 2>&1 ; echo \$?" "0\n" \
+       "" ""
+# Test various data sources and destinations
+
+testing "grep (default to stdin)" "two" "two\n" "" \
+       "one\ntwo\nthree\nthree\nthree\n"
+testing "grep - (specify stdin)" "two -" "two\n" "" \
+       "one\ntwo\nthree\nthree\nthree\n"
+testing "grep input (specify file)" "two input" "two\n" \
+       "one\ntwo\nthree\nthree\nthree\n" ""
+
+# Note that this assumes actual is empty.
+testing "grep input actual (two files)" "two input actual 2> /dev/null" \
+       "input:two\n" "one\ntwo\nthree\nthree\nthree\n" ""
+
+testing "grep - infile (specify stdin and file)" "two - input" \
+       "(standard input):two\ninput:two\n" "one\ntwo\nthree\n" \
+       "one\ntwo\ntoo\nthree\nthree\n"
+
+# Check if we see the correct return value if both stdin and non-existing file
+# are given.
+testing "grep - nofile (specify stdin and nonexisting file)" \
+       "two - nonexistent 2> /dev/null ; echo \$?" \
+       "(standard input):two\n(standard input):two\n2\n" \
+       "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+testing "grep -q - nofile (specify stdin and nonexisting file, no match)" \
+       "-q nomatch - nonexistent 2> /dev/null ; echo \$?" \
+       "2\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+# SUSv3: If the -q option is specified, the exit status shall be zero
+#        if an input line is selected, even if an error was detected.
+testing "grep -q - nofile (specify stdin and nonexisting file, match)" \
+       "-q two - nonexistent ; echo \$?" \
+       "0\n" "" "one\ntwo\ntwo\nthree\nthree\nthree\n"
+
+# Test various command line options
+# -s no error messages
+testing "grep -s nofile (nonexisting file, no match)" \
+       "-s nomatch nonexistent ; echo \$?" "2\n" "" ""
+testing "grep -s nofile - (stdin and nonexisting file, match)" \
+       "-s domatch nonexistent - ; echo \$?" "(standard input):domatch\n2\n" \
+       "" "nomatch\ndomatch\nend\n"
+
+# This doesn't match GNU behaviour (Binary file input matches)
+# acts like GNU grep -a
+testing "grep handles binary files" "foo input" "foo\n" "\0foo\n\n" ""
+# This doesn't match GNU behaviour (Binary file (standard input) matches)
+# acts like GNU grep -a
+testing "grep handles binary stdin" "foo" "foo\n" "" "\0foo\n\n"
+
+testing "grep matches NUL" ". input > /dev/null 2>&1 ; echo \$?" "0\n" "\0\n" ""
+
+# -e regex
+testing "grep handles multiple regexps" "-e one -e two input ; echo \$?" \
+       "one\ntwo\n0\n" "one\ntwo\n" ""
+
+# Depends on FEATURE_GREP_EGREP_ALIAS
+_BB_CONFIG_DEP=FEATURE_GREP_EGREP_ALIAS
+testing "grep -E supports extended regexps" "-E fo+" "foo\n" "" "b\ar\nfoo\nbaz"
+
+exit $FAILCOUNT
diff --git a/testsuite/grep/egrep-is-not-case-insensitive b/testsuite/grep/egrep-is-not-case-insensitive
deleted file mode 100644 (file)
index 8816073..0000000
+++ /dev/null
@@ -1,2 +0,0 @@
-# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
-test x`echo foo | busybox egrep FOO` = x
diff --git a/testsuite/grep/egrep-supports-extended-regexps b/testsuite/grep/egrep-supports-extended-regexps
deleted file mode 100644 (file)
index 6ef8b91..0000000
+++ /dev/null
@@ -1,2 +0,0 @@
-# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
-echo foo | busybox egrep fo+
diff --git a/testsuite/grep/grep-handles-binary-files b/testsuite/grep/grep-handles-binary-files
deleted file mode 100644 (file)
index edb2042..0000000
+++ /dev/null
@@ -1 +0,0 @@
-echo -e '\0foo' | busybox grep foo
diff --git a/testsuite/grep/grep-handles-multiple-regexps b/testsuite/grep/grep-handles-multiple-regexps
deleted file mode 100644 (file)
index 5c1b8de..0000000
+++ /dev/null
@@ -1 +0,0 @@
-echo foo | busybox grep -e foo -e bar
diff --git a/testsuite/grep/grep-is-also-egrep b/testsuite/grep/grep-is-also-egrep
deleted file mode 100644 (file)
index 2e6977c..0000000
+++ /dev/null
@@ -1,2 +0,0 @@
-# FEATURE: CONFIG_FEATURE_GREP_EGREP_ALIAS
-echo foo | busybox egrep foo
diff --git a/testsuite/grep/grep-matches-NUL b/testsuite/grep/grep-matches-NUL
deleted file mode 100644 (file)
index 082bd87..0000000
+++ /dev/null
@@ -1,8 +0,0 @@
-set +e
-echo -e '\0' | busybox grep .
-if [ $? != 0 ] ; then
-       exit 0;
-fi
-
-exit 1;
-
index 7411aec6487aae72df0546d3ac9d4fa0526b9d3a..32ff462d7c57c0fa1e5fb0a9940d566dc0511610 100755 (executable)
@@ -90,21 +90,22 @@ else
 fi
 
 for applet in $applets; do
-       if [ "$applet" == links ]; then continue; fi
-       if [ "$applet" != CVS -a -d "$srcdir/$applet" ]; then
+       if [ "$applet" = "links" ]; then continue; fi
+       if [ "$applet" != "CVS" -a -d "$srcdir/$applet" ]; then
                if run_applet_tests $applet; then
                        :
                else
                        status=1
                fi
        fi
-       applet=`echo "$applet" | sed -n 's/\.tests$//p'`
-       if [ ${#applet} != 0 ]
+       applet=$(echo "$applet" | sed -n 's/\.tests$//p')
+       if [ ${#applet} -ne 0 ]
        then
                mkdir links 2>/dev/null
                rm -f links/"$applet"
                ln -s ${bindir:-../..}/busybox links/"$applet"
-               PATH="$srcdir:$PATH" COMMAND="links/$applet" "${srcdir:-.}/$applet".tests
+               PATH="$srcdir:$PATH" COMMAND="links/$applet" \
+                       "${srcdir:-.}/$applet".tests
                if [ $? -ne 0 ]; then status=1; fi
        fi
 
index b23cf4312b5ea4522381023a6e6cb19844b43422..04d75cfe2e3d0126af9575b0c8ada5edba8f0791 100755 (executable)
@@ -7,6 +7,9 @@
 if [ ${#COMMAND} -eq 0 ]; then COMMAND=sort; fi
 . testing.sh
 
+# Depends on sort
+_BB_CONFIG_DEP=sort
+
 # The basic tests.  These should work even with the small busybox.
 
 testing "sort" "input" "a\nb\nc\n" "c\na\nb\n" ""
index 0925d090d8f70ff21f94f33e6cde7fb53afe5ec8..420cfa1efba4fcc729a73b6691031c86c4322fd0 100755 (executable)
@@ -28,9 +28,19 @@ fi
 
 export FAILCOUNT=0
 
+# Helper functions
+
+config_is_set ()
+{
+  local uc_what=$(echo ${1?} | tr a-z A-Z)
+  grep -q "^[  ]*CONFIG_${uc_what}" ${bindir:-..}/.config || \
+    grep -q "^[        ]*BB_CONFIG_${uc_what}" ${bindir:-..}/.config
+  return $?
+}
+
 # The testing function
 
-function testing()
+testing()
 {
   if [ $# -ne 5 ]
   then
@@ -38,6 +48,15 @@ function testing()
     exit
   fi
 
+  if [ ${force_tests:-0} -ne 1 -a -n "$_BB_CONFIG_DEP" ]
+  then
+    if ! config_is_set "$_BB_CONFIG_DEP"
+    then
+      echo "UNTESTED: $1"
+      return 0
+    fi
+  fi
+
   f=$FAILCOUNT
   echo -ne "$3" > expected
   echo -ne "$4" > input
index 95764740b745ba01cc15660be29c0aed36dc1b30..27d9561e1427be25616c9c15906462eaa7f777b6 100755 (executable)
@@ -9,6 +9,9 @@
 if [ ${#COMMAND} -eq 0 ]; then COMMAND=uniq; fi
 . testing.sh
 
+# Depends on uniq
+_BB_CONFIG_DEP=uniq
+
 # testing "test name" "options" "expected result" "file input" "stdin"
 #   file input will be file called "input"
 #   test can create a file "actual" instead of writing to stdout